#include <stdarg.h>
#include <ncurses/curses.h>

#define printf grub_printf
void grub_printf(const char *fmt, ...)
{
  va_list ap;

  va_start (ap, fmt);
  vwprintw(stdscr, fmt, ap);
  va_end (ap);
}

__inline__ void
gotoxy (int x, int y)
{
  move (y, x);
}

__inline__ void
cls (void)
{
  clear ();
}

void print_border (int y, int size)
{
  int i;

  gotoxy (1, y);

  addch (ACS_ULCORNER);
  for (i = 0; i < 73; i++)
    addch (ACS_HLINE);
  addch (ACS_URCORNER);

  i = 1;

  while (1)
    {
      gotoxy(1, y+i);

      if (i > size)
	break;

      addch (ACS_VLINE);
      gotoxy(75, y+i);
      addch (ACS_VLINE);

      i++;
    }

  addch (ACS_LLCORNER);
  for (i = 0; i < 73; i++)
    addch (ACS_HLINE);
  addch (ACS_LRCORNER);
}

void
set_line(int y, int attr)
{
  mvchgat (y, 2, 74, attr, 7, NULL);
}

int
main()
{
  initscr ();

  cls ();
  printf ("\n    GRUB version %s  (%uK lower / %uK upper memory)\n\n",
	  "0.5", 640, 14336);
  print_border (3, 12);

  gotoxy (2, 4);
  addstr ("ۤ");
  set_line(4, A_REVERSE);
  refresh ();

  endwin ();
  return 0;
}
